﻿using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace TagCloudGenerator
{
    public partial class Form1 : Form
    {
        private Image img;

        //set up for genetic algorithm
        genome[] genomeArray = new genome[10]; //how many should I start with?
        int gnum = 10; //mirror above statement

        //gather data, rectangles, how many times, total area use to determine if potentially possible

        //initialize data storing arrays    
        string[] wordArray;
        string[] wordArrayOrig;
        int[] cntArray;
        int[] cntArrayOrig;

        //to keep record of drawn rectangles
        RectangleF[] recArray = new RectangleF[100];

        int scale = 20;
        int stdScale = 0; //assign first workable scale to this variable to standardize all subsequent ones

        int cntsum = 0;
        int cnt = 0;
        int reccnt = 0;
        int gcnt = 0;

        Random rnd = new Random();

        float totalArea;
        Size screenSize;
        float recArea = 0;

        float canvasX, canvasY;

        Graphics formGraphics;

        public Form1()
        {
            InitializeComponent();

            //determine screenSize
            screenSize = Screen.AllScreens.Select(screen => screen.Bounds).Aggregate(Rectangle.Union).Size;

            img = new Bitmap(screenSize.Width, screenSize.Height);
            formGraphics = Graphics.FromImage(img);

            //totalArea = screenSize.Width * screenSize.Height;
            //MessageBox.Show("Screen Width is " + screenSize.Width + ", Screen Height is " + screenSize.Height);

            //formGraphics = this.CreateGraphics();

           

            
        }

        //changed for my purposes, but based on microsoft example code
        //this function takes a string and its value to generate a rectangle containing the word
        public bool DrawString(string theString, int cntValue)
        {
            Font drawFont = new System.Drawing.Font("Ariel", cntValue); //size should be set according to data
            SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            StringFormat drawFormat = new System.Drawing.StringFormat();

            //randomize only y
            int x,y;

            x = 0;
            y = rnd.Next(screenSize.Height);

            //generate appropriate rectangle
            SizeF param = formGraphics.MeasureString(theString, drawFont);
            Size lw = Size.Round(param);
            Point n = new Point(x, y);

            RectangleF drawRec = new RectangleF(n, param);

            //check if legitimate initial rectangle
            int failures = 0;

            //check for intersection with any other rectangle, inc failures cnt if so
            for (int i = 0; i < reccnt; i++) 
            {
                while (drawRec.IntersectsWith(recArray[i]) || ((drawRec.X + drawRec.Width) >= screenSize.Width) || (drawRec.Y + drawRec.Height > screenSize.Height))
                {
                    //if (drawRec.IntersectsWith(recArray[i]))
                    //    MessageBox.Show("it intersects");

                    if (failures == 100)
                    {
                        //MessageBox.Show("scrapping because too many failures");
                        return false; //exit from function and returns a false
                    }

                    failures++;
                    drawRec.Y = rnd.Next(screenSize.Height);
                    i = 0; //reset i, needs to start from beginning
                }
            }

            //push rectangle to the right until collision, then down until collision

            if (reccnt != 0) //for second one and so on
            {
                //push right until collided
                bool collided = false;
                
                while (!collided)
                {
                    for (int i = 0; i < reccnt; i++) //check for any collisions
                    {
                        if(drawRec.IntersectsWith(recArray[i]) || ((drawRec.X + drawRec.Width) >= screenSize.Width))
                        {
                            collided = true;
                            drawRec.X = drawRec.X - 1;
                        }
                    }
                    drawRec.X = drawRec.X + 1;
                }

                //push down
                collided = false;
                while (!collided)
                {
                    for (int i = 0; i < reccnt; i++) //check for any collisions
                    {
                        if (drawRec.IntersectsWith(recArray[i]) || ((drawRec.Y + drawRec.Height) >= screenSize.Height))
                        {
                            collided = true;
                            drawRec.Y = drawRec.Y - 1;
                        }
                    }
                    drawRec.Y = drawRec.Y + 1;
                }
            }
            else
            {
                //push right until collide
                while ((drawRec.X + drawRec.Width) < screenSize.Width)
                {
                    //MessageBox.Show("here2");
                    drawRec.X = drawRec.X + 1;
                }

                //push down until collide
                while ((drawRec.Y + drawRec.Height) < screenSize.Height)
                {
                    //MessageBox.Show("here2");
                    drawRec.Y = drawRec.Y + 1;
                }
            }


            //add rectangleF to array
            recArray[reccnt] = drawRec; //record into array
            reccnt++;

            recArea = recArea + (drawRec.Width * drawRec.Height);
            //MessageBox.Show("Width: " + drawRec.Width.ToString() + ", Height: " + drawRec.Height.ToString() + ", Area: " + recArea.ToString());

            formGraphics.DrawString(theString, drawFont, drawBrush, drawRec, drawFormat); //draw the string!

            drawFont.Dispose();
            drawBrush.Dispose();

            //MessageBox.Show("HUP");

            return true;
        }
        
        //this function uses a common factor to determine each word's size, and copies over the orignal arrays
        private void processData() //using default scale
        {
            for (int i = 0; i < cnt; i++)
            {
                //reset the cnt and word arrays to the state before the processing(scaling down)
                cntArray[i] = cntArrayOrig[i];
                wordArray[i] = wordArrayOrig[i];

                //make sure font size isn't zero
                if ((cntArray[i] / scale) == 0)
                {
                    cntArray[i] = 1;
                }
                else
                {
                    cntArray[i] = cntArray[i] / scale; //adjust
                }

                //MessageBox.Show(cntArray[i].ToString());

                cntsum = cntsum + cntArray[i];
            }
        }

        private void btMinimize_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void btGenerate_Click(object sender, EventArgs e)
        {
            int tagNum = Convert.ToInt32(numberInput.Value);

            wordArray = new string[tagNum];
            wordArrayOrig = new string[tagNum];
            cntArray = new int[tagNum];
            cntArrayOrig = new int[tagNum];

            //read data into arrays
            try
            {
                using (StreamReader sr = new StreamReader("test2.txt"))
                {
                    string line;

                    for(int i = 0; i < tagNum; i++)
                    {
                        line = sr.ReadLine();
                        string[] splitted = line.Split(' ');
                        wordArrayOrig[cnt] = splitted[0];   
                        //MessageBox.Show(wordArray[cnt]);
                        cntArrayOrig[cnt] = Int32.Parse(splitted[1]);
                        cnt++;
                    }
                    
                    //use a for loop here for the amount user wants
                    //while ((line = sr.ReadLine()) != null)
                    //{
                    //    string[] splitted = line.Split(' ');
                    //    wordArrayOrig[cnt] = splitted[0];
                    //    //MessageBox.Show(wordArray[cnt]);
                    //    cntArrayOrig[cnt] = Int32.Parse(splitted[1]);
                    //    cnt++;
                    //}
                   // MessageBox.Show(cnt.ToString());
                }
            }
            catch (Exception er)
            {
                MessageBox.Show("Can't open file: " + "\r\n" + er.Message, Application.ProductName);
            }

            //make a copy for wordArray
            for(int i = 0; i < cnt; i++)
            {
                wordArray[i] = wordArrayOrig[i];
                cntArray[i] = cntArrayOrig[i];
            }


            randomizeArrays();

            //for(int i = 0; i < cnt; i++)
            //{
            //    MessageBox.Show("BEFORE: " + wordArrayOrig[i] + " " + cntArrayOrig[i] + "\nAfter: " + wordArray[i] + " " + cntArray[i]);
            //}

            processData();

            for (int i = 0; i < gnum; i++)
            {
                randomizeArrays();
                //reset everything
                formGraphics.Clear(Color.White);

                recArray = new RectangleF[100]; //reset the rectangle array
                reccnt = 0;
                recArea = 0;

                if (stdScale == 0)
                    scale = 20;
                else
                    scale = stdScale; //standardize it
                processData(); //reprocess data and sets arrays

                generateTags(); //properly records rectangles into arrays
                //MessageBox.Show(recArea.ToString() + " out of " + totalArea.ToString());
                if (stdScale == 0) //first time, so assign stdScale for all others to use
                    stdScale = scale;
                //MessageBox.Show("stdScale is set to: " + stdScale.ToString());

                //add the genome to generation zero
                genome temp = new genome(recArray, wordArray, cntArray, cnt, recArea);
                genomeArray[gcnt] = temp;

                //update maxHeight and maxWidth of genome
                genomeArray[gcnt].updateHW();

                //MessageBox.Show((recArea / totalArea).ToString());
                //MessageBox.Show("PAUSE");
                gcnt++;
            }

            //determine the canvas size for the genetic algorithm
            canvasX = genomeArray[0].getminX();
            canvasY = genomeArray[0].getminY();
            for(int i = 1; i < gcnt; i++)
            {
                if (genomeArray[i].getminX() < canvasX)
                    canvasX = genomeArray[i].getminX();
                if (genomeArray[i].getminY() < canvasY)
                    canvasY = genomeArray[i].getminY();
            }

            SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            formGraphics.FillEllipse(drawBrush, canvasX, canvasY, 10, 10);
            //MessageBox.Show(canvasX + ", " + canvasY);

            //determine canvas area
            totalArea = (screenSize.Width - canvasX) * (screenSize.Height - canvasY);

            //update genome fitness
            for (int i = 0; i < gcnt; i++)
            {
                genomeArray[i].updateFitness(totalArea, screenSize.Width, screenSize.Height);
            }

            for (int i = 0; i < gcnt; i++)
            {
                //MessageBox.Show(i.ToString() + ": " + genomeArray[i].getWord(0) + " " + genomeArray[i].getRec(0).Width.ToString());
                //MessageBox.Show(genomeArray[i].getFitness().ToString());
            }

            //show the most fit one
            genome mostFit1;
            mostFit1 = genomeArray[0];
            for(int i = 1; i < gcnt; i++)
            {
                if (genomeArray[i].getFitness() < mostFit1.getFitness()) //smaller number means more fit
                    mostFit1 = genomeArray[i];
            }

            MessageBox.Show("Showing most fit of generation zero");
            formGraphics.Clear(Color.White);
            mostFit1.redraw(formGraphics); //it works!

            //get the best clump of each genome, then mutate it retaining that clump
            RectangleF tempRec;
            genome mutGen = genomeArray[0];

            genome[] nextGen = new genome[gnum * 2];

            for(int i = 0; i < gcnt; i++)
            {
                nextGen[i] = genomeArray[i];
            }

            for (int i = 0; i < gcnt; i++)
            {
                tempRec = genomeArray[i].findClump();

                //formGraphics.Clear(Color.White);
                //genomeArray[i].redraw(formGraphics);
                //MessageBox.Show("PAUSE");
                //formGraphics.FillRectangle(drawBrush, tempRec);
                //formGraphics.FillEllipse(drawBrush, tempRec.X, tempRec.Y, 10, 10);
                //formGraphics.FillEllipse(drawBrush, tempRec.X + tempRec.Width, tempRec.Y + tempRec.Height, 10, 10);
                //MessageBox.Show("PAUSE");

                mutGen = genomeArray[i].mutate(tempRec);
                nextGen[i + gcnt] = mutGen;
            }



            //recalculate canvas and fitness of everyone in the new generation
            canvasX = nextGen[0].getminX();
            canvasY = nextGen[0].getminY();
            for (int i = 1; i < (gcnt * 2); i++)
            {
                if (nextGen[i].getminX() < canvasX)
                    canvasX = nextGen[i].getminX();
                if (nextGen[i].getminY() < canvasY)
                    canvasY = nextGen[i].getminY();
            }

            //determine canvas area
            totalArea = (screenSize.Width - canvasX) * (screenSize.Height - canvasY);

            //update genome fitness
            for (int i = 0; i < (gcnt * 2); i++)
            {
                nextGen[i].updateFitness(totalArea, screenSize.Width, screenSize.Height);
            }

            //get the most fit one of the generation
            //show the most fit one
            genome mostFit2;
            mostFit2 = nextGen[0];
            for (int i = 1; i < (gcnt * 2); i++)
            {
                if (nextGen[i].getFitness() < mostFit2.getFitness()) //smaller number means more fit
                    mostFit2 = nextGen[i];
            }


            MessageBox.Show("got here2");
            formGraphics.Clear(Color.White);

            MessageBox.Show("Showing most fit of next generation");
            formGraphics.Clear(Color.White);
            mostFit2.redraw(formGraphics); //it works!

        }

        //this function goes through the data arrays and generates tags
        private bool generateTags()
        {
            //while (DrawString("test", 50))
            //{
            //    MessageBox.Show("HUP");
            //}

            for (int i = 0; i < cnt; i++)
            {
                if (!DrawString(wordArray[i], cntArray[i])) //if ever unable to generate with certain scale
                {
                    //MessageBox.Show("CLEAR");
                    formGraphics.Clear(Color.White);

                    recArray = new RectangleF[100]; //reset the rectangle array
                    reccnt = 0;
                    recArea = 0;

                    if (stdScale != 0) //if subsequent runs
                    {
                        //while it hasn't reached stdScale, keep incrementing scale
                        //but if already exceeding stdScale, then keep scale and retry
                        //if (scale < stdScale)
                        //    scale = scale + 1;

                        scale = stdScale; //always keep it at this scale
                    }
                    else
                        scale = scale + 1;

                    //scale = scale + 1;
                    //MessageBox.Show("scale inc to " + scale.ToString());
                    cntsum = 0;

                    processData(); //reprocess data
                    //MessageBox.Show("scale set to " + scale.ToString());

                    //redraw everything with adjusted scale
                    if (generateTags())
                    {
                        break; //if successful, break
                    }
                }
            }
            return true;
        }

        //randomize the arrays for gen zero, the original ones
        private void randomizeArrays()
        {
            //randomize
            Random r = new Random();
            string tempstr;
            int tempint;

            for (int i = 0; i < cnt; i++)
            {
                //swap content randomly
                int num = r.Next(0, cnt);
                //MessageBox.Show(num.ToString());
                tempstr = wordArrayOrig[i];
                tempint = cntArrayOrig[i];

                //MessageBox.Show(tempstr);

                wordArrayOrig[i] = wordArrayOrig[num];
                cntArrayOrig[i] = cntArrayOrig[num];

                wordArrayOrig[num] = tempstr;
                cntArrayOrig[num] = tempint;
            }

            //MessageBox.Show(wordArray[1]);
            return;
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g2 = this.CreateGraphics();
            g2.DrawImage(img, 0, 0);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        //for testing purposese
        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            //MessageBox.Show(e.X.ToString() + ", " + e.Y.ToString());
        }
    }
}

//genome class
class genome
{
    private RectangleF[] recArray;
    private string[] wordArray;
    private int[] cntArray;
    private float minX, minY; //to get "standardized" canvas
    private float fitness; //the less space left, the stronger its strength, measured using largest screen size
    private int wordcnt;
    private float areaUsed;

    //constructor
    public genome(RectangleF[] recs, string[] words, int[] cntVals, int cnt, float recArea)
    {
        recArray = new RectangleF[cnt];
        wordArray = new string[cnt];
        cntArray = new int[cnt];

        for (int i = 0; i < cnt; i++)
        {
            recArray[i] = recs[i];
            wordArray[i] = words[i];
            cntArray[i] = cntVals[i];
        }

        //need to adjust fitness to get appropriate strength
        fitness = 0; //default set to 0
        minX = 0;
        minY = 0;
        wordcnt = cnt;
        areaUsed = recArea; //I don't think this was ever used
    }

    public float getFitness()
    {
        return fitness;
    }

    public RectangleF getRec(int index)
    {
        return recArray[index];
    }

    public string getWord(int index)
    {
        return wordArray[index];
    }

    public float getminX()
    {
        return minX;
    }

    public float getminY()
    {
        return minY;
    }

    public void updateHW() //update the height and width
    {
        minX = recArray[0].X;
        minY = recArray[0].Y;
        for(int i = 1; i < wordcnt; i++)
        {
            if (recArray[i].X < minX)
                minX = recArray[i].X;
            if (recArray[i].Y < minY)
                minY = recArray[i].Y;
        }
        return;
    }

    public void updateFitness(float totArea, float screenWidth, float screenHeight)
    {
        float genomeArea = (screenWidth - minX) * (screenHeight - minY);
        fitness = (genomeArea / totArea);
    }

    public RectangleF findClump() //find a dense clump, 
    {
        //get first rectangle (lower right), find next  closest rectangle and expand clump to that point -> test for density
        //will aim for a density of 95%?
        RectangleF clump, clumpRet; //clumpRet is the rectangle I want to return
        clumpRet = new RectangleF();
        //this is the index of the word in the original array, it might be one but the its index will now be 0 (Swapped with original word at index 0)
        int startIndex = 0; //start with lower right rectangle, if it doesn't work out, swap with index 2, 3, ... and try again
        int usedcnt = 0;
        int[] used = new int[wordcnt];
        float maxEfficiency = 0;
        string bestWord = "";

        while (startIndex != wordcnt)
        {
            //MessageBox.Show("Starting over");

            clump = recArray[0]; //after it has swapped, use index 0 (does not swap for first iteration)

            //MessageBox.Show("Using " + wordArray[0]);

            used = new int[wordcnt]; //to keep track on rectangles that have been "acquired" into the clump
            usedcnt = 0;

            float distance;
            float areaUsedC = clump.Width * clump.Height; //set up initial clump areaUsed

            float centerX, centerY, recX, recY;
            centerX = clump.X + (clump.Width / 2);
            centerY = clump.Y + (clump.Height / 2);

            int closeIndex = -1; //will crash for input of 1
            float closeDistance = 1000000;

            bool happy = true; //if still happy with clump, continue!

            bool firstone = true;

            while (happy)
            {

                //go through the array of rectangles and find the closest one
                for (int i = 1; i < wordcnt; i++)
                {
                    if (firstone) //if haven't made a single comparison
                    {
                        //compare with second rectangle in the array, initially set as the "closest" rectangle
                        closeIndex = i; //since only 1 compared, it is the closest one so far
                        recX = recArray[i].X + (recArray[i].Width / 2);
                        recY = recArray[i].Y + (recArray[i].Height / 2);
                        closeDistance = (float)Math.Sqrt(((centerX - recX) * (centerX - recX)) + (centerY - recY) * (centerY - recY));
                        firstone = false; // the first one has been done
                    }
                    else //once there is at least one comparison and a distance has been set
                    {
                        //check for used rectangles
                        bool skip = false;
                        for (int j = 0; j < usedcnt; j++)
                        {
                            if (used[j] == i) //if the index of the word being tested has already been used, skip it!
                            {
                                skip = true;
                            }
                        }

                        if (!skip)
                        {
                            //if not used, then continue to compare distances, else ignore
                            recX = recArray[i].X + (recArray[i].Width / 2);
                            recY = recArray[i].Y + (recArray[i].Height / 2);

                            distance = (float)Math.Sqrt(((centerX - recX) * (centerX - recX)) + (centerY - recY) * (centerY - recY));

                            if (distance < closeDistance) //if find a closer rectangle
                            {
                                //set it as the closer one
                                closeDistance = distance;
                                closeIndex = i;
                            }
                        }
                    }
                }

                //add the closest rectangle into the clump
                //find min x and min y between the clump and the new rectangle -> set as new clump X and Y
                float newX = clump.X;
                float newY = clump.Y;
                if (recArray[closeIndex].X < clump.X)
                {
                    newX = recArray[closeIndex].X;
                }
                if (recArray[closeIndex].Y < clump.Y)
                {
                    newY = recArray[closeIndex].Y;
                }

                //need to check LR x and y as well for clumps that aren't right at the bottom right corner
                float recLRX = recArray[closeIndex].X +  recArray[closeIndex].Width;
                float recLRY = recArray[closeIndex].Y + recArray[closeIndex].Height;
                float clumpLRX = clump.X + clump.Width;
                float clumpLRY = clump.Y + clump.Height;

                float newLRX = clumpLRX;
                float newLRY = clumpLRY;

                if(recLRX > clumpLRX)
                {
                    newLRX = recLRX;
                }
                if(recLRY > clumpLRY)
                {
                    newLRY = recLRY;
                }

                //MessageBox.Show("Closest word is " + wordArray[closeIndex]);

                //Adjusting clump
                Size screenSize = Screen.AllScreens.Select(screen => screen.Bounds).Aggregate(Rectangle.Union).Size;

                //need to recalculate width and height
                float newWidth = newLRX - newX;
                float newHeight = newLRY - newY;

                //store original attributes in case of revert
                RectangleF tempClump = clump;
                float tempAreaUsed = areaUsedC;

                //assign new clump
                clump = new RectangleF(newX, newY, newWidth, newHeight);

                //adjust centerX and centerY
                centerX = clump.X + (clump.Width / 2);
                centerY = clump.Y + (clump.Height / 2);

                //problem is HERE, usedcnt == wordcnt causes error
                if (usedcnt < 0 || usedcnt == wordcnt)
                {
                    MessageBox.Show("OH OH " + usedcnt.ToString());
                }
                else
                {
                    //update the array and cnt, as well as areaUsed

                    used[usedcnt] = closeIndex;
                    usedcnt++;
                    areaUsedC = areaUsedC + (recArray[closeIndex].Width * recArray[closeIndex].Height);
                    //reset closeDistance so that it can properly compare
                    closeDistance = 10000000;
                }

                //check if its still a satisfactory clump: at least n words with an efficiency ratio of at least x percent
                float efficiency = areaUsedC / (clump.Width * clump.Height);
                if (efficiency >= .70) //set ratio for clump quality here
                {
                    //MessageBox.Show("This clump is still good! Ratio: " + efficiency.ToString());
                    happy = true;
                }
                else
                {
                    //MessageBox.Show("This clump sucks! Ratio: " + efficiency.ToString());
                    happy = false;

                    //need to revert to past clump by removing the latest addition
                    clump = tempClump;
                    areaUsedC = tempAreaUsed;
                    efficiency = tempAreaUsed / (clump.Width * clump.Height);
                }

                if (!happy) //unhappy means no longer able to continue as a clump
                {
                    //check if it fills the requirements for a good clump
                    if (usedcnt - 1 >= (wordcnt / 20))
                    {
                        //MessageBox.Show("SATISFACTORY");
                        //MessageBox.Show("The clump includes " + usedcnt + " words");

                        //check if more efficient than most efficient clump so far, if so then set as most efficient
                        if (efficiency > maxEfficiency)
                        {
                            maxEfficiency = efficiency;
                            bestWord = wordArray[0]; //how do i return a clump???
                            clumpRet = clump;
                            //MessageBox.Show("best word is now: " + wordArray[0] + " with an efficiency of " + maxEfficiency.ToString());
                        }
                    }


                    //MessageBox.Show("NOT GOOD ENOUGH");
                    //MessageBox.Show("The clump includes " + usedcnt + " words");
                    used = new int[wordcnt];
                    usedcnt = 0;


                    if (startIndex == (wordcnt -1))
                    {
                        //MessageBox.Show("Done!");
                        startIndex++;
                    }
                    else
                    {
                        startIndex++;

                        //do swap here! swap index 0 with the next startIndex, do both recArray and wordArray for consistancy
                        string tempWord;
                        RectangleF tempRec;
                        int tempCnt;

                        tempWord = wordArray[0];
                        wordArray[0] = wordArray[startIndex];
                        wordArray[startIndex] = tempWord;

                        tempRec = recArray[0];
                        recArray[0] = recArray[startIndex];
                        recArray[startIndex] = tempRec;

                        tempCnt = cntArray[0];
                        cntArray[0] = cntArray[startIndex];
                        cntArray[startIndex] = tempCnt;
                    }

                }
            } //end happy loop
        }

        //check if at least one satisfactory clump has been found
        if(maxEfficiency == 0)
        {
            //MessageBox.Show("No satisfactory clump found...");
        }
        else
        {
            //MessageBox.Show("The most efficienct clump starting word is: " + bestWord);
        }

        return clumpRet;
    }

    public void redraw(Graphics genomeGraphics) //redraw the genome 
    {
        for(int i = 0; i < wordcnt; i++)
        {
            Font drawFont = new System.Drawing.Font("Ariel", cntArray[i]); //size should be set according to data
            SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            StringFormat drawFormat = new System.Drawing.StringFormat();
            RectangleF drawRec = recArray[i];

            genomeGraphics.DrawString(wordArray[i], drawFont, drawBrush, drawRec, drawFormat); //draw the string!
        }
        
    }

    public genome mutate(RectangleF clump) //mutation by holding a clump and scramble the rest
    {
        //array of words found within the clump
        string[] inClumpWord = new string[wordcnt];
        int[] inClumpCnt = new int[wordcnt];
        int cnt = 0; //cnt of rectangles in the clump
        //check for all words in the clump
        for(int i = 0; i < wordcnt; i++)
        {
            //check if UL corner and LR corner are within the rectangleF, if so, put in array
            if(recArray[i].X >= clump.X && recArray[i].Y >= clump.Y) //UL corner
            {
                if(((recArray[i].X + recArray[i].Width) <= (clump.X + clump.Width)) && ((recArray[i].Y + recArray[i].Height) <= (clump.Y + clump.Height))) //LR corner
                {
                    inClumpWord[cnt] = wordArray[i]; //store the words and cnt values of the words in the clump
                    inClumpCnt[cnt] = cntArray[i];
                    cnt++;
                }
            }
        }

        for(int i = 0; i < cnt; i++)
        {
            //MessageBox.Show(inClumpWord[i]);
        }

        //maybe having multiple clumps before scrambling would be better? just an idea

        //scramble everything but keep the clump intact as one entity (this is used in the function to produce the new set of arrays)
        //int mutcnt = wordcnt - (cnt - 1);
        //RectangleF[] mutRecArray = new RectangleF[mutcnt]; //this array will have all non-clumped rectangles and the clump
        //int[] mutCntArray = new int[mutcnt];
        //string[] mutWordArray = new string[mutcnt];

        ////set of arrays being used
        //mutRecArray[0] = clump;
        //mutCntArray[0] = 0; //clump word cnt values already previously stored into an array, so would just refer there during generation
        //mutWordArray[0] = "CLUMPWORDS";

        //int mutRecCnt = 1;
        //for (int i = 0; i < wordcnt; i++)
        //{
        //    bool notClumped = true;
        //    for(int j = 0; j < cnt; j++)
        //    {
        //        if (wordArray[i] == inClumpWord[j])
        //            notClumped = false; //found an clump-included word
        //    }

        //    if (notClumped)
        //    {
        //        //put all the words outside the clump into the new set of arrays (starts at index 1 because 0 will be for the clump rectangle)
        //        mutRecArray[mutRecCnt] = recArray[i];
        //        mutCntArray[mutRecCnt] = cntArray[i];
        //        mutWordArray[mutRecCnt] = wordArray[i];
        //        mutRecCnt++;
        //    }
        //}



        //new set of arrays for the new genome
        RectangleF[] newRecArray = new RectangleF[wordcnt];
        int[] newCntArray = new int[wordcnt];
        string[] newWordArray = new string[wordcnt];

        //generate the new genome based on this new array of rectangles
        Random rnd = new Random();
        Size screenSize = Screen.AllScreens.Select(screen => screen.Bounds).Aggregate(Rectangle.Union).Size;

        //randomize only y
        int x, y;

        x = 0;
        y = rnd.Next(screenSize.Height);

        //insert the clump then randomize everything else? sounds good
        RectangleF currentRec = clump; //start working with the clump

        //set clump's y to randomized value and x to 0
        currentRec.X = x;
        currentRec.Y = y;

        //find a legitimate y for the clump to start the tag generation
        while (((currentRec.X + currentRec.Width) >= screenSize.Width) || (currentRec.Y + currentRec.Height > screenSize.Height))
        {
            currentRec.Y = rnd.Next(screenSize.Height);
        }

        //use same method to push rectangles right, then down
        //push right until collide
        while ((currentRec.X + currentRec.Width) < screenSize.Width)
        {
            //MessageBox.Show("here2");
            currentRec.X = currentRec.X + 1;
        }

        //push down until collide
        while ((currentRec.Y + currentRec.Height) < screenSize.Height)
        {
            //MessageBox.Show("here2");
            currentRec.Y = currentRec.Y + 1;
        }

        int newCnt = 0;
        //do the clump words first, then store data in new arrays
        for (int i = 0; i < wordcnt; i++)
        {
            bool notClumped = true;
            for (int j = 0; j < cnt; j++)
            {
                if (wordArray[i] == inClumpWord[j])
                    notClumped = false; //found an clump-included word
            }

            if (!notClumped)
            {
                //set all the in-clump words in the relative same position to get a copy the clump

                //need the offsets of the x and y values of each clump word
                float offsetX = recArray[i].X - clump.X;
                float offsetY = recArray[i].Y - clump.Y;

                //adjust the rectangle x and y
                RectangleF clumpRec = recArray[i];
                clumpRec.X = currentRec.X + offsetX;
                clumpRec.Y = currentRec.Y + offsetY;

                //store in-clump words into the arrays
                newRecArray[newCnt] = clumpRec;
                newCntArray[newCnt] = cntArray[i];
                newWordArray[newCnt] = wordArray[i];

                newCnt++;
            }
        }

        //store checkpoint data here: cnt and array contents in case it can't produce the new genome in one go
        int recordednewCnt = newCnt;
        //RectangleF[] recordedRecArray = new RectangleF[newCnt];
        //int[] recordedCntArray = new int[newCnt];
        //string[] recordedWordArray = new string[newCnt];

        //for(int i = 0; i < newCnt; i++)
        //{
        //    recordedRecArray[i] = newRecArray[i];
        //    recordedCntArray[i] = newCntArray[i];
        //    recordedWordArray[i] = newWordArray[i];
        //}

        bool breakIt = true;
        while (breakIt)
        {
            breakIt = false;

            //reset values here
            newCnt = recordednewCnt;
            //for (int i = 0; i < newCnt; i++)
            //{
            //    newRecArray[i] = recordedRecArray[i];
            //    newCntArray[i] = recordedCntArray[i];
            //    newWordArray[i] = recordedWordArray[i];
            //}


            //do the non-clump words next
            for (int i = 0; i < wordcnt; i++)
            {
                x = 0;
                y = rnd.Next(screenSize.Height);

                bool notClumped = true;
                for (int j = 0; j < cnt; j++)
                {
                    if (wordArray[i] == inClumpWord[j])
                        notClumped = false; //found a clump-included word
                }

                if (notClumped)
                {
                    //do the non-clump rectangles and store in the new set of arrays
                    RectangleF newRec = recArray[i];

                    newRec.X = x;
                    newRec.Y = y;



                    //check if legitimate initial rectangle
                    int failures = 0;

                    //check for intersection with any other rectangle, inc failures cnt if so
                    for (int j = 0; j < newCnt; j++)
                    {
                        while (newRec.IntersectsWith(newRecArray[j]) || ((newRec.X + newRec.Width) >= screenSize.Width) || (newRec.Y + newRec.Height > screenSize.Height))
                        {
                            //if (newRec.IntersectsWith(newRecArray[j]))
                            //MessageBox.Show("it intersects");

                            if (failures == 100)
                            {
                                //MessageBox.Show("scrapping because too many failures");
                                breakIt = true; //reset please!
                            }

                            if (breakIt)
                            {
                                //MessageBox.Show("HERE");
                                break;
                            }

                            failures++;
                            newRec.Y = rnd.Next(screenSize.Height);
                            j = 0; //reset j, needs to start from beginning
                        }
                    }
                    if(breakIt)
                    {
                        break;
                    }

                    //push all the words outside the clump right until collision, then down until collision
                    //check collision with newArrays
                    //push right until collided
                    bool collided = false;

                    while (!collided)
                    {
                        for (int j = 0; j < newCnt; j++) //check for any collisions
                        {
                            if (newRec.IntersectsWith(newRecArray[j]) || ((newRec.X + newRec.Width) >= screenSize.Width))
                            {
                                collided = true;
                                newRec.X = newRec.X - 1;
                            }
                        }
                        newRec.X = newRec.X + 1;
                    }

                    //push down
                    collided = false;
                    while (!collided)
                    {
                        for (int j = 0; j < newCnt; j++) //check for any collisions
                        {
                            if (newRec.IntersectsWith(newRecArray[j]) || ((newRec.Y + newRec.Height) >= screenSize.Height))
                            {
                                collided = true;
                                newRec.Y = newRec.Y - 1;
                            }
                        }
                        newRec.Y = newRec.Y + 1;
                    }



                    //store into newCnt index
                    //store in-clump words into the arrays
                    newRecArray[newCnt] = newRec;
                    newCntArray[newCnt] = cntArray[i];
                    newWordArray[newCnt] = wordArray[i];

                    newCnt++;
                }
            }
        }

        //create the mutated genome and return
        genome temp = new genome(newRecArray, newWordArray, newCntArray, wordcnt, areaUsed);

        return temp;
    }

    public void crossover(genome with)
    {
        //pick a cluster switch them around?
        //would I have to standardize array order for all genomes? (Currently scattered)
    }

    

} //genome class end

//roulette class
class roulette
{
    private float[] weight;
    private Random rng;
    float total;

    //constructor
    public roulette(int population, float[] stats)
    {
        weight = new float[population];
        rng = new Random();
        total = 0;

        weight[0] = stats[0];

        for(int i = 1; i < population; i++)
        {
            weight[i] = weight[i-1] + stats[i];
        }
    }

    //   y = rnd.Next(screenSize.Height);
} //roulette class end

//to do:
//work on how to do crossover and mutation
//mutation algorithm
//function that finds a dense clump (Start LR and find a good initial clump, then expand until not good)
//enlarge word size if lots of white space left on canvas?
